//
//  FirstViewController.m
//  konohana_test
//
//  Created by kunii on 09/11/11.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "FirstViewController.h"
#import "DetailViewController.h"
#import "NewFlowerViewController.h"

@interface Contribute : NSObject {
	UIImage*	photo;
	NSString*	name;
	NSString*	comment;
	int			contributeID;
}
@property (nonatomic, retain) UIImage*	photo;
@property (nonatomic, retain) NSString*	name;
@property (nonatomic, retain) NSString*	comment;
@property (nonatomic, assign) int		contributeID;
@end

@implementation Contribute
@synthesize photo;
@synthesize name;
@synthesize comment;
@synthesize contributeID;
-(void)dealloc {
	[super dealloc];
}
@end


#define TABLE_ROW_HEIGHT 100
enum {
	tag_Photo = 1,
	tag_Name,
	tag_Comment
};

@implementation FirstViewController

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

- (IBAction)modalViewAction:(id)sender
{
	if (contributionViewController == nil)
        contributionViewController = [[NewFlowerViewController alloc] init];

	[self.navigationController presentModalViewController:contributionViewController animated:YES];
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	UIButton* modalViewButton = [UIButton buttonWithType:UIButtonTypeContactAdd];
	[modalViewButton addTarget:self action:@selector(modalViewAction:) forControlEvents:UIControlEventTouchUpInside];
	UIBarButtonItem *modalBarButtonItem = [[UIBarButtonItem alloc] initWithCustomView:modalViewButton];
	self.navigationItem.rightBarButtonItem = modalBarButtonItem;
	[modalBarButtonItem release];

	self.tableView.rowHeight = TABLE_ROW_HEIGHT;
	result = [[NSMutableArray alloc] init];
	db = [[KonohanaDB alloc] init];
	db.dbDelegate = self;
	[db connect];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc {
	[db release];
	[result release];
	[autoreleased_str release];
	[contributionViewController release];
    [super dealloc];
}

#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [result count];
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath 
{
	static NSString *CellIdentifier = @"Cell";    
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
		UIImageView* imageview = [[UIImageView alloc] initWithFrame:CGRectMake(5,5,TABLE_ROW_HEIGHT - 10,TABLE_ROW_HEIGHT - 10)];
		imageview.tag = tag_Photo;
		[cell addSubview:imageview];
		UILabel* nameLabel = [[UILabel alloc] initWithFrame:CGRectMake(TABLE_ROW_HEIGHT, 10, 200, 40)];
		nameLabel.tag = tag_Name;
		[cell addSubview:nameLabel];
		UILabel* commentLabel = [[UILabel alloc] initWithFrame:CGRectMake(TABLE_ROW_HEIGHT, 50, 200, 40)];
		commentLabel.tag = tag_Comment;
		[cell addSubview:commentLabel];
	}
	//	各ラベルへの掲示板の内容設定。
	Contribute* c = [result objectAtIndex:indexPath.row];
	UIImageView* imageview = (UIImageView*)[cell viewWithTag:tag_Photo];
	imageview.image = c.photo;
	UILabel* label = (UILabel*)[cell viewWithTag:tag_Name];
	label.text = c.name;
	label = (UILabel*)[cell viewWithTag:tag_Comment];
	label.text = c.comment;
    return cell;
}

/*
	イベント項目の一つが選ばれた。
*/
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)newIndexPath
{
	printf("autoreleased_str releaseCount = %d\n", [autoreleased_str retainCount]);
	printf("db releaseCount = %d\n", [db retainCount]);
	DetailViewController* ctl = [[DetailViewController alloc] initWithNibName:@"SecondView" bundle:nil];
	UITableViewCell* cell = [tableView cellForRowAtIndexPath:newIndexPath];
	UIImageView* imageview = (UIImageView*)[cell viewWithTag:tag_Photo];
	ctl.image = imageview.image;

	UILabel* name = (UILabel*)[cell viewWithTag:tag_Name];
	ctl.title = name.text;

	[self.navigationController pushViewController:ctl animated:YES];
	[ctl release];
}

//	提案が見つかった。
-(void)arrivedContribution:(int)inID photo:(UIImage*)photo name:(NSString*)name comment:(NSString*)comment
{
	Contribute* c = [[[Contribute alloc] init] autorelease];
	c.photo = photo;
	c.name = name;
	c.comment = comment;
	c.contributeID = inID;
	[result addObject:c];
}

//	接続完了。
-(void)terminate
{
	[self.tableView reloadData];
}
@end
